<?php
// ----------------------------------------------------------------------
// Copyright (c) 2002-2006 Shawn McKenzie
// http://spidean.mckenzies.net
// ----------------------------------------------------------------------
//
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
//
// ----------------------------------------------------------------------

if (!defined('ADMIN_FILE')) {
	die ("Access Denied");
}

$module_name = basename(dirname(__FILE__));
get_lang($module_name);

define('THEFILE', "$admin_file.php");

function nukewrap_admin_defaults()
{
    nukewrapAdminHeader();

    include(dirname(__FILE__)."/nukewrap.cfg");

    $y1 = $y2 = $y3 = $y4 = $y5 = $a5 = $y6 = "";
    $n1 = $n2 = $n3 = $n4 = $n5 = $n6 = " checked";

    if ($general['url-security']) { $y1 = " checked"; $n1 = ""; }
    if ($general['strict']) { $y6 = " checked"; $n6 = ""; }
    if ($general['local-pages-only']) { $y2 = " checked"; $n2 = ""; }
    if ($general['auto-resize']) { $y3 = " checked"; $n3 =""; }
    if ($general['border']) { $y4 = " checked"; $n4 =""; }

    switch ($general['scroll']) {
        case 'yes':
            $y5 = " checked";
            $n5 = "";
            break;

        case 'no':
            $n5 = " checked";
            break;

        case 'auto':
            $a5 = " checked";
            $n5 = "";
            break;
    }
    $height = $general['height'];
    $width = $general['width'];
    $marginheight = $general['marginheight'];
    $marginwidth = $general['marginwidth'];

    echo "
    <b>"._DEFAULTS."</b><br /><br />
    <form action=\"".THEFILE."?module=NukeWrap&op=savedefaults\" method=\"post\" enctype=\"application/x-www-form-urlencoded\">
        "._DISPLAYURL."
        <input$y1 type=\"radio\" name=\"url-security\" value=\"1\" />"._YES."
        <input$n1 type=\"radio\" name=\"url-security\" value=\"0\" />"._NO."
        <br />
        <font color=\"red\">"._SECURITYNOTE."</font>
        <br /><br />
        "._STRICTCHECK."
        <input$y6 type=\"radio\" name=\"strict\" value=\"1\" />"._YES."
        <input$n6 type=\"radio\" name=\"strict\" value=\"0\" />"._NO."
        <br />
        "._STRICTNOTE."
        <br /><br />
        "._DISPLAYOFFSITE."
        <input$y2 type=\"radio\" name=\"local-pages-only\" value=\"1\" />"._YES."
        <input$n2 type=\"radio\" name=\"local-pages-only\" value=\"0\" />"._NO."
        <br /><br />
        "._AUTORESIZE."
        <input$y3 type=\"radio\" name=\"auto-resize\" value=\"1\" />"._YES."
        <input$n3 type=\"radio\" name=\"auto-resize\" value=\"0\" />"._NO."
        <br /><br />
        "._HEIGHT.":
        <input type=\"text\" name=\"height\" value=\"$height\" size=\"4\" maxlength=\"4\" />
        <br />
        "._HEIGHTNOTE."
        <br /><br />
        "._WIDTH.":
        <input type=\"text\" name=\"width\" value=\"$width\" size=\"4\" maxlength=\"4\" />
        <br /><br />
        "._MARGINHEIGHT.":
        <input type=\"text\" name=\"marginheight\" value=\"$marginheight\" size=\"4\" maxlength=\"4\" />
        <br /><br />
        "._MARGINWIDTH.":
        <input type=\"text\" name=\"marginwidth\" value=\"$marginwidth\" size=\"4\" maxlength=\"4\" />
        <br /><br />
        "._BORDER."
        <input$y4 type=\"radio\" name=\"border\" value=\"1\" />"._YES."
        <input$n4 type=\"radio\" name=\"border\" value=\"0\" />"._NO."
        <br /><br />
        "._SCROLLBARS."
        <input$y5 type=\"radio\" name=\"scroll\" value=\"yes\" />"._YES."
        <input$n5 type=\"radio\" name=\"scroll\" value=\"no\" />"._NO."
        <input$a5 type=\"radio\" name=\"scroll\" value=\"auto\" />"._AUTO."
        <br /><br />
        <input type=\"submit\" value=\""._SAVE."\" />
    </form><hr />";

    nukewrapAdminFooter();
}

function nukewrap_admin_list()
{
    nukewrapAdminHeader();

    include(dirname(__FILE__)."/nukewrap.cfg");

    $y3 = $y4 = $y5 = $a5 = "";
    $n3 = $n4 = $n5 =" checked";

    if ($general['auto-resize']) { $y3 = " checked"; $n3 =""; }
    if ($general['border']) { $y4 = " checked"; $n4 =""; }

    switch ($general['scroll']) {
        case 'yes':
            $y5 = " checked";
            $n5 = "";
            break;

        case 'no':
            $n5 = " checked";
            break;

        case 'auto':
            $a5 = " checked";
            $n5 = "";
            break;
    }
    $height = $general['height'];
    $width = $general['width'];
    $marginheight = $general['marginheight'];
    $marginwidth = $general['marginwidth'];

    echo "<b>"._URLLIST."</b><br /><br />
    <table width=\"100%\"><tr><td><b>"._ALIAS."</b></td><td><b>"._URL."</b></td><td><b>"._ACTION."</b></td></tr>";

    $id = 0;
    if (!empty($authorized_url)) {
        foreach ($authorized_url as $k => $v) {
            $alias = $v['alias'];
            echo "<tr><td>$alias</td><td>$k</td>
            <td>[ <a href=\"".THEFILE."?module=NukeWrap&op=editurl&alias=$alias&id=$id\">"._EDIT."</a> ]
            [ <a href=\"".THEFILE."?module=NukeWrap&op=delurl&alias=$alias&id=$id\">"._DELETE."</a> ]</td></tr>";
            $id++;
        }
    }
    else {
        echo "<td>"._NOURLSDEFINED."</td><td></td><td></td></tr>";
    }
    echo "</table><br /><hr />";

    echo "
    <b>"._ADDURL."</b><br /><br />
    <form action=\"".THEFILE."?module=NukeWrap&op=addurl\" method=\"post\" enctype=\"application/x-www-form-urlencoded\">
        "._ALIAS.":&nbsp;<input type=\"text\" name=\"alias\" value=\"\" size=\"20\" />
        <br /><br />
        "._URL.":&nbsp;&nbsp;<input type=\"text\" name=\"url\" value=\"\" size=\"50\" />
        <br /><br />
        "._AUTORESIZE."
        <input$y3 type=\"radio\" name=\"auto-resize\" value=\"1\" />"._YES."
        <input$n3 type=\"radio\" name=\"auto-resize\" value=\"0\" />"._NO."
        <br /><br />
        "._HEIGHT.":
        <input type=\"text\" name=\"height\" value=\"$height\" size=\"4\" maxlength=\"4\" />
        <br />
        "._HEIGHTNOTE."
        <br /><br />
        "._WIDTH.":
        <input type=\"text\" name=\"width\" value=\"$width\" size=\"4\" maxlength=\"4\" />
        <br /><br />
        "._MARGINHEIGHT.":
        <input type=\"text\" name=\"marginheight\" value=\"$marginheight\" size=\"4\" maxlength=\"4\" />
        <br /><br />
        "._MARGINWIDTH.":
        <input type=\"text\" name=\"marginwidth\" value=\"$marginwidth\" size=\"4\" maxlength=\"4\" />
        <br /><br />
        "._BORDER."
        <input$y4 type=\"radio\" name=\"border\" value=\"1\" />"._YES."
        <input$n4 type=\"radio\" name=\"border\" value=\"0\" />"._NO."
        <br /><br />
        "._SCROLLBARS."
        <input$y5 type=\"radio\" name=\"scroll\" value=\"yes\" />"._YES."
        <input$n5 type=\"radio\" name=\"scroll\" value=\"no\" />"._NO."
        <input$a5 type=\"radio\" name=\"scroll\" value=\"auto\" />"._AUTO."
        <br /><br />
        <input type=\"submit\" value=\""._ADD."\" />
    </form><hr />";

    nukewrapAdminFooter();
}

function nukewrap_admin_editurl($vars)
{
    nukewrapAdminHeader();

    include(dirname(__FILE__)."/nukewrap.cfg");

    $y3 = $y4 = $y5 = $a5 = "";
    $n3 = $n4 = $n5 =" checked";

    foreach ($authorized_url as $k => $v) {
        if ($v['alias'] == $vars['alias']) {
            $url = $k;
            $general = $v;
            break;
        }
    }
    if ($general['auto-resize']) { $y3 = " checked"; $n3 =""; }
    if ($general['border']) { $y4 = " checked"; $n4 =""; }

    switch ($general['scroll']) {
        case 'yes':
            $y5 = " checked";
            $n5 = "";
            break;

        case 'no':
            $n5 = " checked";
            break;

        case 'auto':
            $a5 = " checked";
            $n5 = "";
            break;
    }
    $id = $vars['id'];
    $alias = $general['alias'];
    $height = $general['height'];
    $width = $general['width'];
    $marginheight = $general['marginheight'];
    $marginwidth = $general['marginwidth'];

    echo "
    <b>"._EDITURL."</b><br /><br />
    <form action=\"".THEFILE."?module=NukeWrap&op=saveurl&id=$id\" method=\"post\" enctype=\"application/x-www-form-urlencoded\">
        "._ALIAS.":&nbsp;<input type=\"text\" name=\"alias\" value=\"$alias\" size=\"20\" />
        <br /><br />
        "._URL.":&nbsp;&nbsp;<input type=\"text\" name=\"url\" value=\"$url\" size=\"50\" />
        <br /><br />
        "._AUTORESIZE."
        <input$y3 type=\"radio\" name=\"auto-resize\" value=\"1\" />"._YES."
        <input$n3 type=\"radio\" name=\"auto-resize\" value=\"0\" />"._NO."
        <br /><br />
        "._HEIGHT.":
        <input type=\"text\" name=\"height\" value=\"$height\" size=\"4\" maxlength=\"4\" />
        <br />
        "._HEIGHTNOTE."
        <br /><br />
        "._WIDTH.":
        <input type=\"text\" name=\"width\" value=\"$width\" size=\"4\" maxlength=\"4\" />
        <br /><br />
        "._MARGINHEIGHT.":
        <input type=\"text\" name=\"marginheight\" value=\"$marginheight\" size=\"4\" maxlength=\"4\" />
        <br /><br />
        "._MARGINWIDTH.":
        <input type=\"text\" name=\"marginwidth\" value=\"$marginwidth\" size=\"4\" maxlength=\"4\" />
        <br /><br />
        "._BORDER."
        <input$y4 type=\"radio\" name=\"border\" value=\"1\" />"._YES."
        <input$n4 type=\"radio\" name=\"border\" value=\"0\" />"._NO."
        <br /><br />
        "._SCROLLBARS."
        <input$y5 type=\"radio\" name=\"scroll\" value=\"yes\" />"._YES."
        <input$n5 type=\"radio\" name=\"scroll\" value=\"no\" />"._NO."
        <input$a5 type=\"radio\" name=\"scroll\" value=\"auto\" />"._AUTO."
        <br /><br />
        <input type=\"submit\" value=\""._SAVE."\" />
    </form><hr />";

    nukewrapAdminFooter();
}

function nukewrap_admin_savedefaults($vars)
{
    $general['url-security'] = $vars['url-security'];
    $general['strict'] = $vars['strict'];
    $general['local-pages-only'] = $vars['local-pages-only'];
    $general['auto-resize'] = $vars['auto-resize'];
    $general['height'] = $vars['height'];
    $general['width'] = $vars['width'];
    $general['marginheight'] = $vars['marginheight'];
    $general['marginwidth'] = $vars['marginwidth'];
    $general['border'] = $vars['border'];
    $general['scroll'] = $vars['scroll'];

    $cfg = compact("general");
    nukewrapSaveConfig($cfg);

    header("Location: ".THEFILE."?module=NukeWrap&op=defaults");
    exit;
}

function nukewrap_admin_delurl($vars)
{
    include(dirname(__FILE__)."/nukewrap.cfg");

    foreach ($authorized_url as $k => $v) {
        if ($v['alias'] == $vars['alias']) {
            break;
        }
    }
    unset($authorized_url[$k]);

    $cfg = compact("authorized_url");
    nukewrapSaveConfig($cfg);

    header("Location: ".THEFILE."?module=NukeWrap&op=list");
    exit;
}

function nukewrap_admin_saveurl($vars)
{
    include(dirname(__FILE__)."/nukewrap.cfg");

    $id = 0;
    foreach ($authorized_url as $k => $v) {
        if ($id == $vars['id']) {
            break;
        }
        $id++;
    }
    unset($authorized_url[$k]);

    $cfg = compact("authorized_url");
    nukewrapSaveConfig($cfg);

    nukewrap_admin_addurl($vars);
}

function nukewrap_admin_addurl($vars)
{
    include(dirname(__FILE__)."/nukewrap.cfg");

    foreach ($authorized_url as $k => $v) {
        if (empty($vars['alias']) ||
            empty($vars['url']) ||
            $v['alias'] == $vars['alias'] ||
            $k == $vars['url'])
        {
            header("Location: ".THEFILE."?module=NukeWrap&op=list");
            exit;
        }
    }
    $url['alias'] = $vars['alias'];
    $url['auto-resize'] = $vars['auto-resize'];
    $url['height'] = $vars['height'];
    $url['width'] = $vars['width'];
    $url['marginheight'] = $vars['marginheight'];
    $url['marginwidth'] = $vars['marginwidth'];
    $url['border'] = $vars['border'];
    $url['scroll'] = $vars['scroll'];

    $authorized_url[$vars['url']] = $url;

    $cfg = compact("authorized_url");
    nukewrapSaveConfig($cfg);

    header("Location: ".THEFILE."?module=NukeWrap&op=list");
    exit;
}

function nukewrapSaveConfig($cfg)
{
    include(dirname(__FILE__)."/nukewrap.cfg");

    extract($cfg);

    $content = "<?php\n"
    .'$general = '
    .var_export($general, TRUE)
    .";\n"
    .'$authorized_url = '
    .var_export($authorized_url, TRUE)
    .";\n";
    $content .= "?>";

    $handle = fopen(dirname(__FILE__)."/nukewrap.cfg", "w");
	fwrite($handle, $content);
	fclose($handle);
}

function nukewrapAdminHeader()
{
    include("header.php");

    echo "
    <div align=\"center\">
    <a href=\"".THEFILE."\">"._ADMINISTRATION."</a><br /><br />
    [ <a href=\"".THEFILE."?module=NukeWrap&op=defaults\">"._DEFAULTS."</a> | <a href=\"".THEFILE."?module=NukeWrap&op=list\">"._URLLIST."</a> ]
    </div><br />";

    if (!is_writable(dirname(__FILE__)."/nukewrap.cfg")) {
        echo "<font color=\"red\">nukewrap.cfg "._CONFIGNOTWRITABLE."</font>";
    }
    echo "<hr />";
}

function nukewrapAdminFooter()
{
    echo "<div align=\"center\">
    NukeWrap 2.0<br />
    Copyright (c) 2002-2006 Shawn McKenzie<br />
    <a href=\"http://spidean.mckenzies.net\" target=\"_blank\">http://spidean.mckenzies.net</a>
    </div>";

    include("footer.php");
}

/**********************************/
/* Compatibility functions        */
/**********************************/
if (!function_exists("file_get_contents")) {
    function file_get_contents($filename)
    {
        if (@is_file($filename)) {
            $result = "";
            $handle = @fopen($filename, "r");
            if (!$handle) {
                return false;
            }
            while (!feof($handle)) {
                $result .= fread($handle, 4096);
            }
            return $result;
        }
        else {
            return false;
        }
    }
}

if (!function_exists("var_export")) {
    function var_export($var)
    {
        $result = "";

        switch (gettype($var)) {
            case "array":
                reset($var);
                $result = "array(\n";
                foreach ($var as $k => $v) {
                    $result .= "  " . var_export($k)." => " . var_export($v).",\n";
                }
                $result .= ")";
                break;

            case "string":
                $result = "'$var'";
                break;

            case "boolean":
                $result = ($var) ? "true" : "false";
                break;

            default:
                if (empty($var)) {
                    $result = "''";
                }
                else {
                    $result = $var;
                }
                break;
        }
        return $result;
    }
}

?>