<?php
// ----------------------------------------------------------------------
// Copyright (c) 2002-2006 Shawn McKenzie
// http://spidean.mckenzies.net
// ----------------------------------------------------------------------
//
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
//
// ----------------------------------------------------------------------

if (!defined('MODULE_FILE')) {
    die ("You can't access this file directly...");
}

$module_name = basename(dirname(__FILE__));
get_lang($module_name);

include("header.php");
include(dirname(__FILE__)."/nukewrap.cfg");

// Check that a page was specified
if(!isset($_GET['page']) || ($_GET['page'] == "")) {
	nukewrap_error(_NOPAGEMSG);
}
else {
    $page = $_GET['page'];
}

// Check if URL is in URL List
$checked = false;

foreach($authorized_url as $url => $v) {

    // Fuzzy matching of URL List
    if (!$general['strict']) {
        if (eregi($url, $page) || eregi($url, "http://".$page)) {
            $checked = true;
        }
    }
	if (($v['alias'] == $page) || ($url == $page) || ($url == "http://".$page)) {
        $checked = true;
	    $page = $url;
        // Override general settings
		foreach($general as $key => $new) {
            if(isset($v[$key])) {
                $newval[$key] = $v[$key];
            }
            else {
                $newval[$key] = $new;
            }
        }
        if($newval) {
            $general = array_merge((array)$general, (array)$newval);
            unset($newval);
        }
	}
}
// Check that page is in URL list if url-security is enabled
if($general['url-security']) {
    if(!$checked) {
        nukewrap_error(_NOTAUTHHOSTMSG);
    }
}

// Assign settings to vars to be used
$allow_local_only = $general['local-pages-only'];
$auto_resize = $general['auto-resize'];
$vsize = $general['height'];
$hsize = $general['width'];
$marginheight = $general['marginheight'];
$marginwidth = $general['marginwidth'];
$border = $general['border'];
$scroll = $general['scroll'];

// Check for not local page if set
$url_parts = parse_url($page);

if($allow_local_only &&
	($url_parts['host'] != $_SERVER["SERVER_NAME"]) &&
	($url_parts['host'] != $_SERVER["HTTP_HOST"]))
{
	nukewrap_error(_NOTLOCALMSG);
}

// Check if height, width or resize were passed in URL
if($_GET['height']) {
    $vsize = $_GET['height'];
    $auto_resize = false;
}
if($_GET['width']) {
    $hsize = $_GET['width'];
}
elseif(!$hsize) {
    $hsize = "100%";
}
if($_GET['resize']) {
    $auto_resize = $_GET['resize'];
}

// If auto_resize ie enabled then build javascript content
if($auto_resize) {
	$js_content = "\n\n<!-- Begin NukeWrap Auto-Resize -->\n"
		."<script language=\"javascript\" type=\"text/javascript\" src=\"modules/NukeWrap/javascript/nukewrap.js\"></script>\n"
		."<!-- End NukeWrap Auto-Resize -->\n\n";

	$vsize = "100%";
}
else {
    $js_content = "";
}

// Build and display iframe content
$nw_content = "\n\n<!-- Begin NukeWrap Content -->\n"
."<iframe id=\"nukewrap-content\" class=\"nukewrap-content\" src=\"$page\" width=\"$hsize\" height=\"$vsize\" "
."frameborder=\"$border\" marginheight=\"$marginheight\" marginwidth=\"$marginwidth\" scrolling=\"$scroll\">\n"
._SORRYBROWSER1."<a class=\"title\" href=\"$page\" target=\"_blank\">"._LINKYOU."</a>"._SORRYBROWSER2."\n"
."</iframe>\n"
."<!-- End NukeWrap Content -->\n\n";

// Display it all
echo $nw_content;
echo $js_content;
include("footer.php");

// Function called if something is not right and we need to display a message and quit
function nukewrap_error($title)
{
	$err_content =  "\n<div class=\"title\">".$title."</div>\n";
	echo $err_content;
	include("footer.php");
	die();
}

?>